#include "chromosome.h"
#include <iostream>
#include <stdlib.h>

using namespace std;

int random(int max);

Chromosome::Chromosome() : fitness{0}
{
	for (int i=0; i < SIZE; ++i) {
		m_genes[i] = random(MAX_VOLUME);
	}
}

Chromosome* Chromosome::mutate()
{
	Chromosome* child = new Chromosome;
	for (int i=0; i < SIZE; ++i) {
		child->m_genes[i] = m_genes[i];
	}
	int pos = random(SIZE);
	int mutation = random(MAX_VOLUME);
	child->m_genes[pos] = mutation;
	return child;
}

Chromosome* Chromosome::crossover(const Chromosome* const c)
{
	int pos = random(SIZE);
	Chromosome* child = new Chromosome;
	for (int i=0; i < pos; ++i) {
		child->m_genes[i] = m_genes[i];
	}
	for (int i=pos; i < SIZE; ++i) {
		child->m_genes[i] = c->m_genes[i];
	}
	return child;
}

const unsigned short int* Chromosome::genes() const
{
	return m_genes;
}

const unsigned short int Chromosome::gene(const int i) const
{
	return m_genes[i];
}

bool operator==(const Chromosome a, const Chromosome b)
{
	return a.fitness == b.fitness;
}

bool operator!=(const Chromosome a, const Chromosome b)
{
	return !(a == b);
}

bool operator<(const Chromosome a, const Chromosome b)
{
	return a.fitness < b.fitness;
}

bool operator>=(const Chromosome a, const Chromosome b)
{
	return !(a<b);
}

bool operator<=(const Chromosome a, const Chromosome b)
{
	return (a<b) || (a==b);
}

bool operator>(const Chromosome a, const Chromosome b)
{
	return !(a<=b);
}
